import processing.core.*; 
import processing.data.*; 
import processing.opengl.*; 

import de.bezier.data.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class sunUpSunDown6_onlyoneatatime extends PApplet {

/*
Loads all data from the sheet
 pressing 1-7 turns the city visualisations on/off
 
 */


// import library


// declare variables
XlsReader reader;
PFont myFont, myBoldFont;
boolean inside = false;
int dayLength;
int upABit = 15;
String locationName = "";
int cols=8;
int rows=366;
int location=0;
int[][][] allSunSheets = new int[7][cols][rows];

int[] locations = {  1, 0, 0, 0, 0, 0, 0 };
String[] locationNames = {
  "San Francisco", "Amsterdam", "New York", "Jakarta", "Auckland", "Milan", "Invercargill"
};
int[] locationColors = {
  10, 30, 50, 70, 100, 120, 140
};
String[] monthNames = { "JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"};



//int[] sun = new int[8];
int x, y, z;
int earliest = 500;
int latest = 500; 
int lastMonth = 0;
int barColor = 250;
int offset = 0; // this is the margin to the left

// setup, all the work is done here

public void setup ()
{
  size(365*3+offset, 750);
  // size(100,100);
  stroke(2);
  fill( 0 );
  background( 255 );
  smooth();
  loadSheets();
  colorMode(HSB);
  myFont = createFont("HelveticaNeue-Bold", 14);
  myBoldFont = createFont("HelveticaNeue-Bold", 18, true);

  textFont(myFont);
}

public void draw() {
  background(255);

  monthBars();
  hourLines();
  printSheet();
  smile();
}


public void keyPressed() {
  for (int x = 0; x<locations.length; x++) {
    locations[x]=0;
  }
  if (key == '1' && locations[1]==0) locations[1] = 1;
  else if (key == '2' && locations[2]==0) locations[2] = 1;
  else if (key == '3' && locations[3]==0) locations[3] = 1;
  else if (key == '4' && locations[4]==0) locations[4] = 1;
  else if (key == '5' && locations[5]==0) locations[5] = 1;
  else if (key == '6' && locations[6]==0) locations[6] = 1;
  else if (key == '0' && locations[0]==0) locations[0] = 1;
  else locations[1]=1;
}

public void hourLines() {
  for (int hour = 0; hour<=24; hour++) {
    stroke(255, 100);
    strokeWeight(1);
    line(offset, hour*60/2, width, hour*60/2);
    noStroke();
    fill(255, 100);
    textAlign(RIGHT);
    if (hour!=0)    text(hour, 15, hour*60/2+15);
    textAlign(LEFT);
    stroke(0);

    fill(0);
  }
}

// determining the last month
public void monthBars() {
  for (int x = 0; x<rows-1; x++) {
    int thisMonth = (allSunSheets[0][0][x]);
    barColor = 64+(128/24*thisMonth);
    fill(barColor);
    noStroke();
    rect(x*3, 0, 4, height);
  }

  for (int y = 0; y<monthNames.length; y++) {
    fill(255,100);
    textAlign(CENTER);
    text(monthNames[y], 45+y*90, 25);
    textAlign(LEFT);
  }
}

public void loadSheets() {
  reader = new XlsReader( this, "sunriseSunsets.xls" );

  for (int location = 0; location<locations.length; location++) {
    z=0;
    reader.openSheet(location);
    reader.firstRow();
    String titleSheet = reader.getString();    // the title of the original dataset is in the first row, first cell
    reader.nextRow(); // legend
    while ( reader.hasMoreRows () )    // loop thru rows
    {

      // jump to first data row and its first cell
      // don't forget this or you'll be stuck in an endless loop
      reader.nextRow();    
      if (z<366) z++;

      int month = reader.getInt();    // month
      allSunSheets[location][0][z-1] = month;

      if ( month < 1 ) break;    // exit loop once we reach the end of the values, and they become smaller than 1 basically

      reader.nextCell();    // day
      allSunSheets[location][1][z-1] = reader.getInt(); 

      reader.nextCell();    // upHour
      allSunSheets[location][2][z-1] = reader.getInt();

      reader.nextCell();    // upMin
      allSunSheets[location][3][z-1] = reader.getInt(); 

      reader.nextCell();    // downHour
      allSunSheets[location][4][z-1] = reader.getInt();

      reader.nextCell();    // downMin
      allSunSheets[location][5][z-1] = reader.getInt();

      int upTime = (allSunSheets[location][2][z-1]*60)+allSunSheets[location][3][z-1];
      int downTime = (allSunSheets[location][4][z-1]*60)+allSunSheets[location][5][z-1];
      allSunSheets[location][6][z-1] = upTime;
      allSunSheets[location][7][z-1] = downTime;
    }
  }
}

public void printSheet() {
  for (int x = 0; x < locations.length; x++) {
    if (locations[x] == 1) {
      int location = x;
      for (int z = 0; z<rows-1; z++) {
        int sunUpToday = (allSunSheets[location][6][z])/2;
        int sunDownToday = (allSunSheets[location][7][z])/2;

        fill(locationColors[location], 230, 255);
        stroke(locationColors[location], 230, 255);
        //println (sunUpToday);
        ellipse (offset+z*3, sunUpToday, 1, 1);
        ellipse (offset+z*3, sunDownToday, 1, 1);
        fill(locationColors[location], 230, 255, 10);
        stroke(locationColors[location], 230, 255, 10);

        rect(offset+z*3, sunUpToday, 3, sunDownToday-sunUpToday);
        /*  textFont(myBoldFont);
         strokeWeight(0);
         text(locationNames[location], offset*2, 50+15*location);
         textFont(myFont); 
         strokeWeight(2);
         */
      }
    }
  }
  // Prints the location names along the bottom
  for (int x = 0; x < locations.length; x++) {
    fill(locationColors[x], 230, 255);
    textFont(myBoldFont);
    strokeWeight(0);
    text(locationNames[x], 45+150*x, height-35);
    text(x + ":", 28+150*x, height-35);
    textFont(myFont); 
    strokeWeight(2);
  }
  // Prints the location names below eachother
  /* for (int x = 0; x < locations.length; x++) {
   fill(locationColors[x], 230, 255);
   textFont(myBoldFont);
   strokeWeight(0);
   text(locationNames[x], 45, 22+30*x);
   text(x + ":", 28, 22+30*x);
   
   textFont(myFont); 
   strokeWeight(2);
   }*/

  // Prints the location names along the top
  /* for (int x = 0; x < locations.length; x++) {
   fill(locationColors[x], 230, 255);
   textFont(myBoldFont);
   strokeWeight(0);
   text(locationNames[x], 45+150*x, 50);
   text(x + ":", 28+150*x, 50);
   
   textFont(myFont); 
   strokeWeight(2);
   }*/
}

public void smile() {

  for (int x = 0; x < locations.length; x++) {
    if (locations[x] == 1) {
      int location = x;

      if ((mouseX-offset)/3 > 0) {
        int xLocation = (mouseX-offset)/3;
        int tempTextMonth = allSunSheets[location][0][xLocation];
        int tempTextDay = allSunSheets[location][1][xLocation];
        int tempTextSunUpHour = allSunSheets[location][2][xLocation];
        int tempTextSunUpMin = allSunSheets[location][3][xLocation];
        int tempTextSunDownHour = allSunSheets[location][4][xLocation];
        int tempTextSunDownMin = allSunSheets[location][5][xLocation];
        int tempSunUpTimeY = allSunSheets[location][6][xLocation]/2;
        int tempSunDownTimeY = allSunSheets[location][7][xLocation]/2;
        int barLength = tempSunDownTimeY-tempSunUpTimeY;
        dayLength = barLength;
        noStroke();

        fill(200, 0, 0);
        rect(mouseX, tempSunUpTimeY, 3, barLength);
        if (mouseY>tempSunUpTimeY && mouseY<tempSunDownTimeY) inside = true;
        else inside = false;

        if (inside) {
          ellipse(mouseX+3, mouseY-upABit, 40, 40);
          fill(255);
          textAlign(CENTER);
          textFont(myBoldFont);
          textFont(myFont);
          fill(locationColors[location], 230, 255);
          //stroke(locationColors[location], 230, 255);
          if (mouseX<(width/2)) {
            textAlign(LEFT);
            text("In " + locationNames[location] + " on " + monthNames[tempTextMonth-1] + " " + tempTextDay + "\nThe Sun will rise at " + tempTextSunUpHour + ":" + tempTextSunUpMin + 
              " The Sun will set at " 
              + tempTextSunDownHour + ":" + tempTextSunDownMin + "\nFor a total of " + dayLength/30 + " hours of sunlight", mouseX+30, mouseY-30);
          }
          else if (mouseX>(width/2)) {
            textAlign(RIGHT);
            text("In " + locationNames[location] + " on " + monthNames[tempTextMonth-1] + " " + tempTextDay + "\nThe Sun will rise at " + tempTextSunUpHour + ":" + tempTextSunUpMin + 
              " The Sun will set at " 
              + tempTextSunDownHour + ":" + tempTextSunDownMin + "\nFor a total of " + dayLength/30 + " hours of sunlight", mouseX-30, mouseY-30);
          }
        }   
        textAlign(LEFT);

        fill(0);
      }
    }
  }

  if (inside) {
    pushMatrix();
    translate(mouseX, mouseY-upABit);
    int smileWidth = 30;
    int smileDepth = PApplet.parseInt(map(dayLength, 280, 450, 0, 18));
    int beginPointX = -13;
    int beginPointY = 0;
    fill(0);
    stroke(255, 0, 255);
    strokeWeight(3);
    bezier(beginPointX, beginPointY, beginPointX, beginPointY+smileDepth, beginPointX+smileWidth, beginPointY+smileDepth, beginPointX+smileWidth, beginPointY);
    ellipse(-3, -7, 3, 3);
    ellipse(7, -7, 3, 3);
    popMatrix();
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "sunUpSunDown6_onlyoneatatime" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
